#!/bin/bash
# change userAgent of Vivaldi WebPanel on Ubuntu
# sudo execution is requied.
# last modified at 2015-12-02
# more detail -> http://freefielder.jp/lab/vivaldi/

# Original userAgent string  
S="Linux; Android [0-9]\+\.[0-9]\+\.[0-9]\+"
# replace to 
R="iPhone; CPU iPhone OS 9_1 like Mac OS X"

# find path of bundle.js
IFS_BAK=$IFS
IFS=$'\n'
VIV_DIR=($(ls /opt | grep 'vivaldi'))
IFS=$IFS_BAK

NUM_OF_DIR=${#VIV_DIR[*]}

if [ $NUM_OF_DIR -eq 0 ]; then
	echo;echo 'Vivaldi not found.'
	exit 0
elif [ $NUM_OF_DIR -ge 2 ]; then
	echo;echo ${NUM_OF_DIR}' Vivaldies are found. Choose one and input number.'
	N=1
	for obj in "${VIV_DIR[@]}"; do
		echo $N') '${VIV_DIR[`expr $N - 1`]}
		N=`expr $N + 1`
	done
	printf ">> "
	read N
#
	expr $N + 1 >/dev/null 2>&1
	if [ $? -ge 2 ]; then
		echo "bad input."
		exit 0
	fi
#
else
	N=1
fi

if [ $N -le $NUM_OF_DIR ]; then
	NN=`expr $N - 1`
#	echo ${N}') '${VIV_DIR[$NN]}
	BNDL='/opt/'${VIV_DIR[$NN]}'/resources/vivaldi/bundle.js'
else
	echo 'bad input.'
	exit 0
fi


echo ''
echo 'File location : '"$BNDL"
echo '>> Continue ? : Y or N'
read CONTFLAG
 
if ! [ -z $CONTFLAG ] && [ $CONTFLAG = 'Y' -o $CONTFLAG = 'y' ] ; then
	if ! [ -e $BNDL ] || [ -d $BNDL ]; then
		echo 'file not exist'
		exit 0
	fi
else
	echo 'exit'
	exit 0
fi

# create backup file as 'bundle.js.bkup{timestamp}' in the same place with this script.
SHDIR=$(cd $(dirname $0) && pwd)
TIMESTAMP=`date '+%Y%m%d%H%M'`
BKUP="${SHDIR}/bundle.js.bkup${TIMESTAMP}"

cp "$BNDL" "$BKUP"
sed "s/$S/$R/" "$BKUP" > "$BNDL"

echo 'UserAgent changed.'
echo 'backup file : '"$BKUP"
